# -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is Mozilla Communicator client code, released
# March 31, 1998.
#
# The Initial Developer of the Original Code is
# Netscape Communications Corporation.
# Portions created by the Initial Developer are Copyright (C) 1998-2000
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#   Jan Varga <varga@nixcorp.com>
#   HÂkan Waara (hwaara@chello.se)
#   Postbox, Inc. <contact@postbox-inc.com>
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
var gMessengerBundle = document.getElementById("bundle_messenger");

// Controller object for folder pane
var FolderPaneController =
{
   supportsCommand: function(command)
  {
    switch ( command )
    {
      case "cmd_delete":
      case "button_delete":
      //case "cmd_selectAll": the folder pane currently only handles single selection
      case "cmd_cut":
      case "cmd_copy":
      case "cmd_paste":
        return true;
      default:
        return false;
    }
  },

  isCommandEnabled: function(command)
  {
    if (!FolderPaneSelectionIsMailFolder())
      return false;
    switch ( command )
    {
      case "cmd_cut":
      case "cmd_copy":
      case "cmd_paste":
        return false;
      case "cmd_delete":
      case "button_delete":
      if ( command == "cmd_delete" )
        goSetMenuValue(command, 'valueFolder');
      var folderTree = GetFolderTree();
      var startIndex = {};
      var endIndex = {};
      folderTree.view.selection.getRangeAt(0, startIndex, endIndex);
      if (startIndex.value >= 0) {
        var canDeleteThisFolder;
        var isServer = null;
        var serverType = null;
        var folder = GetFolderResource(folderTree, startIndex.value);
        if (folder instanceof Components.interfaces.nsIMsgFolder)
        {
          isServer = folder.isServer;
          serverType = folder.server.type;
          if (serverType == "nntp") {
             if ( command == "cmd_delete" ) {
                goSetMenuValue(command, 'valueNewsgroup');
                goSetAccessKey(command, 'valueNewsgroupAccessKey');
            }
          }
          if (isServer || !folder.deletable ||
              (folder.flags & MSG_FOLDER_FLAG_JUNK && !CanRenameDeleteJunkMail(GetSelectedFolderURI())))
            canDeleteThisFolder = false;
          else
            canDeleteThisFolder = true;
          return canDeleteThisFolder && isCommandEnabled(command);
        }
        else
          return false;
      }
      else
        return false;

      default:
        return false;
    }
  },

  doCommand: function(command)
  {
    // if the user invoked a key short cut then it is possible that we got here for a command which is
    // really disabled. kick out if the command should be disabled.
    if (!this.isCommandEnabled(command)) return;

    switch ( command )
    {
      case "cmd_delete":
      case "button_delete":
        MsgDeleteFolder();
        break;
    }
  },

  onEvent: function(event)
  {
  }
};

// DefaultController object (handles commands when one of the trees does not have focus)
var DefaultController =
{
  supportsCommand: function(command)
  {
    switch ( command )
    {
      case "cmd_createFilterFromPopup":
      case "cmd_close":
      case "cmd_closeWindow":
      case "cmd_shiftReplyall":
      case "cmd_shiftReply":
      case "cmd_quickreply":
      case "cmd_reply":
      case "cmd_replyall":
      case "button_reply":
      case "button_replyall":
      case "cmd_forward":
      case "button_forward":
      case "cmd_forwardInline":
      case "cmd_forwardAttachment":
      case "cmd_editMsg":
      case "button_send":
      case "button_redirect":
      case "cmd_editAsNew":
      case "cmd_redirect":
      case "cmd_createFilterFromMenu":
      case "cmd_delete":
      case "button_delete":
      case "button_junk":
      case "cmd_shiftDelete":
      case "cmd_nextMsg":
      case "button_next":
      case "button_previous":
      case "cmd_nextUnreadMsg":
      case "cmd_nextFlaggedMsg":
      case "cmd_nextUnreadThread":
      case "cmd_previousMsg":
      case "cmd_previousUnreadMsg":
      case "cmd_previousFlaggedMsg":
      case "button_goForward":
      case "button_goBack":
      case "cmd_goForward":
      case "cmd_goBack":
      case "cmd_goHome":
      case "cmd_toggleMessagePane":
      case "cmd_toggleFolderPane":
      case "cmd_toggleFocusPane":
      case "button_pbStatusBarOptions":
      case "cmd_toggleInspectorPane":
      case "cmd_expandConversationMsgs":
      case "cmd_collapseConversationMsgs":
      case "cmdShowQuickswitch":
      case "cmd_quicksearch":
      case "cmd_viewMessages":
      case "cmd_viewAttachments":
      case "cmd_viewImages": 
      case "cmd_viewtodos":
      case "cmd_viewAllMsgs":
      case "cmd_viewUnreadMsgs":
      case "cmd_viewThreadsWithUnread":
      case "cmd_viewWatchedThreadsWithUnread":
      case "cmd_viewIgnoredThreads":
      case "cmd_undo":
      case "cmd_redo":
      case "cmd_expandAllThreads":
      case "cmd_collapseAllThreads":
      case "cmd_renameFolder":
      case "cmd_sendUnsentMsgs":
      case "cmd_subscribe":
      case "cmd_openMessage":
      case "button_print":
      case "cmd_print":
      case "cmd_printpreview":
      case "cmd_printSetup":
      case "cmd_saveAsFile":
      case "cmd_saveAsTemplate":
      case "cmd_properties":
      case "cmd_favoritefolder":
      case "cmd_viewPageSource":
      case "cmd_setFolderCharset":
      case "cmd_reload":
      case "button_getNewMessages":
      case "cmd_getNewMessages":
      case "cmd_getMsgsForAuthAccounts":
      case "cmd_getNextNMessages":
      case "cmd_find":
      case "cmd_findAgain":
      case "cmd_findPrevious":
      case "cmd_search":
      case "cmd_fullTextSearch":
      case "button_mark":
      case "button_archive":
      case "cmd_archive":
      case "cmd_tag":
      case "cmd_toggleRead":
      case "cmd_markAsUnread":
      case "cmd_markAsRead":
      case "cmd_markAllRead":
      case "cmd_markThreadAsRead":
      case "cmd_togglePending":
      case "cmd_markAsPending":
      case "cmd_markAsNotPending":
      case "cmd_markReadByDate":
      case "cmd_toggleFlagged":
      case "cmd_markAsFlagged":
      case "cmd_markAsNotFlagged":
      case "cmd_toggleJunk":
      case "cmd_markAsJunk":
      case "cmd_markAsNotJunk":
      case "cmd_recalculateJunkScore":
      case "cmd_applyFilters":
      case "cmd_runJunkControls":
      case "cmd_indexAllMessages":
      case "cmd_indexMessagesInFolder":
      case "cmd_resetIndexAllMessages":
      case "cmd_resetIndexMessagesInFolder":
      case "cmd_suggestIndexAllMessages":
      case "cmd_suggestIndexMessagesInFolder":
      case "cmd_deleteJunk":
      case "cmdShowQuickfile":
      case "button_file":
      case "cmd_file":
      case "cmd_emptyTrash":
      case "cmd_compactFolder":
      case "cmd_settingsOffline":
      case "cmd_close":
      case "cmd_closeWindow":
      case "cmd_selectAll":
      case "cmd_selectThread":
      case "cmd_moveToFolderAgain":
      case "cmd_newTask":
      case "button_newTask":
      case "cmd_rename":
        return true;
      case "cmd_downloadFlagged":
      case "cmd_downloadSelected":
      case "cmd_synchronizeOffline":
        return MailOfflineMgr.isOnline();

      case "cmd_watchThread":
      case "cmd_killThread":
        return(isNewsURI(GetFirstSelectedMessage()));
      default:
        return false;
    }
  },

  isCommandEnabled: function(command)
  {
    var enabled = new Object();
    enabled.value = false;
    var checkStatus = new Object();

    // special case a few commands like get new mail which are supported when editing a message.
    // This list is a little different from the commands we enable when showing rich search.
    var currentTabOwner = document.getElementById('tabmail').currentTabOwner;
    var folderResource = GetFolderResource(GetFolderTree(), GetSelectedFolderIndex());

    switch ( command )
    {
      case "cmd_delete":
        UpdateDeleteCommand();
        // fall through
      case "button_delete":
        if (gDBView)
          gDBView.getCommandStatus(nsMsgViewCommandType.deleteMsg, enabled, checkStatus);
        return enabled.value;
      case "cmd_shiftDelete":
        if (gDBView)
          gDBView.getCommandStatus(nsMsgViewCommandType.deleteNoTrash, enabled, checkStatus);
        return enabled.value;
      case "button_archive":
      case "cmd_archive":
        if (gDBView)
          gDBView.getCommandStatus(nsMsgViewCommandType.archive, enabled, checkStatus);
        return enabled.value;
      case "cmd_newTask":
      case "button_newTask":
        return IsNewTaskEnabled();
      case "button_junk":
        UpdateJunkToolbarButton();
        if (gDBView)
          gDBView.getCommandStatus(nsMsgViewCommandType.junk, enabled, checkStatus);
        return enabled.value;
      case "cmd_killThread":
        return GetNumSelectedMessages() > 0;
      case "cmd_watchThread":
        if (gDBView)
          gDBView.getCommandStatus(nsMsgViewCommandType.toggleThreadWatched, enabled, checkStatus);
        return enabled.value;
      case "cmd_createFilterFromPopup":
      case "cmd_createFilterFromMenu":
        var loadedFolder = GetLoadedMsgFolder();
        if (!(loadedFolder && loadedFolder.server.canHaveFilters))
          return false;   // else fall thru
      case "cmd_saveAsFile":
        return GetNumSelectedMessages() > 0;
      case "cmd_saveAsTemplate":
        if (GetNumSelectedMessages() > 1)
          return false;   // else fall thru
      case "cmd_quickreply":
        return IsMessageDisplayedInMessagePane();
      case "cmd_shiftReplyall":
      case "cmd_shiftReply":
      case "cmd_reply":
      case "button_reply":
      case "cmd_replyall":
      case "button_replyall":
      case "cmd_forward":
      case "button_forward":
      case "cmd_forwardInline":
      case "cmd_forwardAttachment":
      case "button_send":
      case "cmd_openMessage":
      case "button_print":
      case "cmd_print":
      case "cmd_viewPageSource":
      case "cmd_reload":
        if (GetNumSelectedMessages() > 0)
        {
          if (gDBView)
          {
            gDBView.getCommandStatus(nsMsgViewCommandType.cmdRequiringMsgBody, enabled, checkStatus);
            return enabled.value;
          }
        }
        return false;
      case "button_redirect":  
      case "cmd_redirect":
        // cmd_redirect gets disabled for unsent folders which is why it is different from cmd_reply, etc.
        if (GetNumSelectedMessages() > 0)
        {
          if (gDBView)
          {
            gDBView.getCommandStatus(nsMsgViewCommandType.cmdRequiringMsgBody, enabled, checkStatus);
            let loadedFolder = GetLoadedMsgFolder();
            return enabled.value && !(loadedFolder && loadedFolder.flags & MSG_FOLDER_FLAG_QUEUE);
          }
        }
        return false;            
      case "cmd_editAsNew":
        // cmd_editAsNew gets disabled for unsent folders which is why it is different from cmd_reply, etc.
        if (GetNumSelectedMessages() > 0)
        {
          if (gDBView)
          {
            gDBView.getCommandStatus(nsMsgViewCommandType.cmdRequiringMsgBody, enabled, checkStatus);
            let loadedFolder = GetLoadedMsgFolder();
            return enabled.value && !(loadedFolder && loadedFolder.flags & MSG_FOLDER_FLAG_QUEUE);
          }
        }
        return false;
      case "cmd_editMsg":
        // cmd_editMsg gets disabled for news which is why it is different from cmd_editAsNew, cmd_reply, etc.
        if (GetNumSelectedMessages() == 1)
        {
          if (gDBView && !GetThreadTree().view.isContainer(GetSelectedIndices(gDBView)[0]))
          {
            gDBView.getCommandStatus(nsMsgViewCommandType.cmdRequiringMsgBody, enabled, checkStatus);
            return enabled.value && !isNewsURI(GetFirstSelectedMessage());
          }
        }
        return false;
      case "cmd_printpreview":
        if ( GetNumSelectedMessages() == 1 && gDBView)
        {
           gDBView.getCommandStatus(nsMsgViewCommandType.cmdRequiringMsgBody, enabled, checkStatus);
           return enabled.value;
        }
        return false;
      case "cmd_printSetup":
        return true;
      case "cmd_markAsNotFlagged":
      case "cmd_toggleFlagged":
      case "cmd_markAsFlagged":
      case "cmdShowQuickfile":
      case "button_file":
      case "cmd_file":
        return (GetNumSelectedMessages() > 0 );
      case "cmd_markAsNotPending":
      case "cmd_markAsPending":
      case "cmd_togglePending":
      case "cmd_toggleJunk":
      case "cmd_markAsJunk":
      case "cmd_markAsNotJunk":
        // can't do news on junk yet.
        return (GetNumSelectedMessages() > 0 && !isNewsURI(GetFirstSelectedMessage()));
      case "cmd_rename":
        gDBView.getCommandStatus(nsMsgViewCommandType.rename, enabled, checkStatus);
        return enabled.value;
      case "cmd_recalculateJunkScore":
        if (GetNumSelectedMessages() > 0)
          gDBView.getCommandStatus(nsMsgViewCommandType.runJunkControls, enabled, checkStatus);
        return enabled.value;
      case "cmd_applyFilters":
        if (gDBView)
          gDBView.getCommandStatus(nsMsgViewCommandType.applyFilters, enabled, checkStatus);
        return enabled.value;
      case "cmd_runJunkControls":
        if (gDBView)
          gDBView.getCommandStatus(nsMsgViewCommandType.runJunkControls, enabled, checkStatus);
        return enabled.value;
      case "cmd_deleteJunk":
        if (gDBView)
          gDBView.getCommandStatus(nsMsgViewCommandType.deleteJunk, enabled, checkStatus);
        return enabled.value;
      case "button_mark":
        return true;
      case "cmd_tag":
      case "cmd_toggleRead":
      case "cmd_markThreadAsRead":
        return GetNumSelectedMessages() > 0;
      case "cmd_markAsRead":
        return CanMarkMsgAsRead(true);
      case "cmd_markAsUnread":
        return CanMarkMsgAsRead(false);
      case "button_previous":
      case "button_next":
        return IsViewNavigationItemEnabled();
      case "cmd_nextMsg":
      case "cmd_nextUnreadMsg":
      case "cmd_nextUnreadThread":
      case "cmd_previousMsg":
      case "cmd_previousUnreadMsg":
        return IsViewNavigationItemEnabled();
      case "button_goForward":
      case "button_goBack":
      case "cmd_goForward":
      case "cmd_goBack":
        if (gDBView)
          enabled.value = gDBView.navigateStatus((command == "cmd_goBack" || command == "button_goBack") ? nsMsgNavigationType.back : nsMsgNavigationType.forward);
        return enabled.value;
      case "cmd_goHome":
      case "cmd_resetIndexAllMessages":
      case "cmd_indexAllMessages":
        return true;
      case "cmd_resetIndexMessagesInFolder":
      case "cmd_indexMessagesInFolder":
        // disable this command if what we have selected isn't a msg folder.
        // see bug #2626 for details
        return (GetMsgFolderFromUri(GetSelectedFolderURI(), true) != null);
      case 'cmd_suggestIndexAllMessages':
        var msgFolder = GetMsgFolderFromUri(GetSelectedFolderURI(), true);
        return (msgFolder == null && ShouldSuggestIndexing(msgFolder));
      case 'cmd_suggestIndexMessagesInFolder':
        // disable this command if what we have selected isn't a msg folder.
        // see bug #2626 for details
        var msgFolder = GetMsgFolderFromUri(GetSelectedFolderURI(), true);
        return (msgFolder != null && ShouldSuggestIndexing(msgFolder));
      case "cmd_markAllRead":
      case "cmd_markReadByDate":
        return IsFolderSelected();
      case "cmd_find":
      case "cmd_findAgain":
      case "cmd_findPrevious":
      case "cmd_toggleInspectorPane":
        return IsMessageDisplayedInMessagePane();
        break;
      case "cmd_expandConversationMsgs":
      case "cmd_collapseConversationMsgs":
        return IsMessageDisplayedInMessagePane() && InConversationMode();
      case "cmd_fullTextSearch":
        return currentTabOwner.type != 'message';
        break;
      case "cmd_search":
        return IsCanSearchMessagesEnabled();
      case "cmd_selectAll":
        return gDBView != null;
      // these are enabled on when we are in threaded mode
      case "cmd_selectThread":
        if (GetNumSelectedMessages() <= 0) return false;
      case "cmd_expandAllThreads":
      case "cmd_collapseAllThreads":
        return (gDBView.viewFlags & nsMsgViewFlagsType.kThreadedDisplay);
      case "cmd_nextFlaggedMsg":
      case "cmd_previousFlaggedMsg":
        return IsViewNavigationItemEnabled();
      case "cmd_toggleFocusPane":
      case "button_pbStatusBarOptions":
      case "cmd_toggleMessagePane":
      case "cmd_toggleFolderPane":
      case "cmdShowQuickswitch":
      case "cmd_quicksearch":
      case "cmd_viewMessages":
      case "cmd_viewAttachments":
      case "cmd_viewtodos":
      case "cmd_viewImages": 
        return true;
      case "cmd_viewAllMsgs":
      case "cmd_viewUnreadMsgs":
      case "cmd_viewIgnoredThreads":
        return gDBView;
      case "cmd_viewThreadsWithUnread":
      case "cmd_viewWatchedThreadsWithUnread":
        return gDBView && !(GetSelectedMsgFolders()[0].flags & 
                            MSG_FOLDER_FLAG_VIRTUAL);
      case "cmd_stop":
        return true;
      case "cmd_undo":
      case "cmd_redo":
          return SetupUndoRedoCommand(command);
      case "cmd_renameFolder":
        return IsRenameFolderEnabled();
      case "cmd_sendUnsentMsgs":
        return IsSendUnsentMsgsEnabled(null);
      case "cmd_subscribe":
        return IsSubscribeEnabled();
      case "cmd_favoriteFolders":
        return FolderPaneSelectionIsMailFolder();
      case "cmd_properties":
        return IsPropertiesEnabled(command);
      case "button_getNewMessages":
      case "cmd_getNewMessages":
      case "cmd_getMsgsForAuthAccounts":
        return IsGetNewMessagesEnabled();
      case "cmd_getNextNMessages":
        return IsGetNextNMessagesEnabled();
      case "cmd_emptyTrash":
        return IsEmptyTrashEnabled();
      case "cmd_compactFolder":
        return IsCompactFolderEnabled();
      case "cmd_setFolderCharset":
        return IsFolderCharsetEnabled();
      case "cmd_close":
      case "cmd_closeWindow":
        return true;
      case "cmd_downloadFlagged":
        return(IsFolderSelected() && MailOfflineMgr.isOnline());
      case "cmd_downloadSelected":
        return (IsFolderSelected() && MailOfflineMgr.isOnline() && GetNumSelectedMessages() > 0);
      case "cmd_synchronizeOffline":
        return MailOfflineMgr.isOnline() && IsAccountOfflineEnabled();
      case "cmd_settingsOffline":
        return IsAccountOfflineEnabled();
      case "cmd_moveToFolderAgain":
        let targetURI = pref.getCharPref("mail.last_msg_movecopy_target_uri");
        if (!targetURI)
          return false;
        let targetFolder = GetMsgFolderFromUri(targetURI, true);
        // If parent is null, folder doesn't exist.
        return targetFolder && targetFolder.parent &&
               GetNumSelectedMessages() > 0;
      default:
        return false;
    }
    return false;
  },

  doCommand: function(command)
  {
    // if the user invoked a key short cut then it is possible that we got here for a command which is
    // really disabled. kick out if the command should be disabled.
    if (!this.isCommandEnabled(command)) return;

    switch ( command )
    {
      case "cmd_close":
        CloseMailWindow();
        break;
      case "cmd_closeWindow":
        pbMailTryToCloseWindow();
        break;
      case "button_getNewMessages":
      case "cmd_getNewMessages":
        MsgGetMessage();
        break;
      case "cmd_getMsgsForAuthAccounts":
        MsgGetMessagesForAllAuthenticatedAccounts();
        break;
      case "cmd_getNextNMessages":
        MsgGetNextNMessages();
        break;
      case "cmd_shiftReplyall":
      case "cmd_replyall":
      case "cmd_shiftReply":
      case "cmd_reply":
        MsgReply(command == 'cmd_reply' || command == 'cmd_replyall',
                 command == 'cmd_replyall' || command == 'cmd_shiftReplyall', false);
        break;
      case "cmd_quickreply":
        MsgFocusQuickReply();
        break;
      case "cmd_forward":
        MsgForwardMessage(null);
        break;
      case "cmd_forwardInline":
        MsgForwardAsInline(null);
        break;
      case "cmd_forwardAttachment":
        MsgForwardAsAttachment(null);
        break;
      case "cmd_editMsg":
        MsgEditMessage();
        break;
      case "cmd_editAsNew":
        MsgEditMessageAsNew();
        break;
      case "cmd_redirect":
        MsgRedirect();
        break;
      case "cmd_createFilterFromMenu":
        MsgCreateFilter();
        break;
      case "cmd_createFilterFromPopup":
        break;// This does nothing because the createfilter is invoked from the popupnode oncommand.
      case "button_delete":
      case "cmd_delete":
         // if the user deletes a message before its mark as read timer goes off, we should mark it as read
         // this ensures that we clear the biff indicator from the system tray when the user deletes the new message
        MarkSelectedMessagesRead(true);
        SetNextMessageAfterDelete();
        gDBView.doCommand(nsMsgViewCommandType.deleteMsg);
        break;
      case "cmd_shiftDelete":
        MarkSelectedMessagesRead(true);
        SetNextMessageAfterDelete();
        gDBView.doCommand(nsMsgViewCommandType.deleteNoTrash);
        break;
      case "cmd_archive":
        if (gMarkViewedMessageAsReadTimer)
          MarkCurrentMessageAsRead();
        SetNextMessageAfterDelete();
        gDBView.doCommand(nsMsgViewCommandType.archive);
        break;
      case "cmd_killThread":
        /* kill thread kills the thread and then does a next unread */
        GoNextMessage(nsMsgNavigationType.toggleThreadKilled, true);
        break;
      case "cmd_watchThread":
        gDBView.doCommand(nsMsgViewCommandType.toggleThreadWatched);
        break;
      case "button_next":
      case "cmd_nextUnreadMsg":
        MsgNextUnreadMessage();
        break;
      case "cmd_nextUnreadThread":
        MsgNextUnreadThread();
        break;
      case "cmd_nextMsg":
        MsgNextMessage();
        break;
      case "cmd_nextFlaggedMsg":
        MsgNextFlaggedMessage();
        break;
      case "cmd_previousMsg":
        MsgPreviousMessage();
        break;
      case "button_previous":
      case "cmd_previousUnreadMsg":
        MsgPreviousUnreadMessage();
        break;
      case "cmd_previousFlaggedMsg":
        MsgPreviousFlaggedMessage();
        break;
      case "button_goForward":
      case "cmd_goForward":
        MsgGoForward();
        break;
      case "button_goBack":
      case "cmd_goBack":
        MsgGoBack();
        break;
      case "cmd_goHome":
        goHome();
        break;
      case "cmd_toggleFocusPane":
        SetFocusPaneVisibility(true);
        break;
      case "cmd_toggleFolderPane":
        SetFolderPaneVisibility(true);
        break;
      case "cmd_toggleMessagePane":
        MsgToggleMessagePane();
        break;
      case "cmd_toggleInspectorPane":
        SetInspectorPaneVisibility(true);
        break;
      case "cmd_expandConversationMsgs":
      case "cmd_collapseConversationMsgs":
        toggleSlimMessagesInConversation(command == 'cmd_expandConversationMsgs');
        break;
      case "cmd_viewAllMsgs":
      case "cmd_viewThreadsWithUnread":
      case "cmd_viewWatchedThreadsWithUnread":
      case "cmd_viewUnreadMsgs":
      case "cmd_viewIgnoredThreads":
        SwitchView(command);
        break;
      case "cmd_undo":
        messenger.undo(msgWindow);
        break;
      case "cmd_redo":
        messenger.redo(msgWindow);
        break;
      case "cmd_expandAllThreads":
        gDBView.doCommand(nsMsgViewCommandType.expandAll);
        break;
      case "cmd_collapseAllThreads":
        gDBView.doCommand(nsMsgViewCommandType.collapseAll);
        break;
      case "cmd_renameFolder":
        MsgRenameFolder();
        return;
      case "cmd_subscribe":
        MsgSubscribe();
        return;
      case "cmd_sendUnsentMsgs":
        MsgSendUnsentMsgs();
        return;
      case "cmd_openMessage":
        MsgOpenSelectedMessages();
        return;
      case "cmd_printSetup":
        PrintUtils.showPageSetup();
        return;
      case "cmd_print":
        PrintEnginePrint();
        return;
      case "cmd_printpreview":
        PrintEnginePrintPreview();
        return;
      case "cmd_saveAsFile":
        MsgSaveAsFile();
        return;
      case "cmd_saveAsTemplate":
        MsgSaveAsTemplate();
        return;
      case "cmd_viewPageSource":
        MsgViewPageSource();
        return;
      case "cmd_setFolderCharset":
        MsgSetFolderCharset();
        return;
      case "cmd_reload":
        MsgReload();
        return;
      case "cmd_find":
        // make sure the message pane has focus before we start a find since we only support searching
        // within the message body. Do it here and not in MsgFind() which can be called from standalone where we don't want to set focus
        SetFocusMessagePane();
        MsgFind();
        return;
      case "cmd_findAgain":
        // make sure the message pane has focus before we start a find since we only support searching
        // within the message body. Do it here and not in MsgFind() which can be called from standalone where we don't want to set focus
        SetFocusMessagePane();
        MsgFindAgain(false);
        return;
      case "cmd_findPrevious":
        // make sure the message pane has focus before we start a find since we only support searching
        // within the message body. Do it here and not in MsgFind() which can be called from standalone where we don't want to set focus
        SetFocusMessagePane();
        MsgFindAgain(true);
        return;
      case "cmd_markReadByDate":
        MsgMarkReadByDate();
        return;
      case "cmd_favoritefolder":
        ToggleFavoriteFolderFlag();
        return;
      case "cmd_properties":
        MsgFolderProperties();
        return;
      case "cmd_fullTextSearch":
        QuickSearchFocus();
        return;
      case "cmd_search":
        MsgSearchMessages();
        return;
      case "button_mark":
      case "cmd_toggleRead":
        MsgMarkMsgAsRead();
        return;
      case "cmd_markAsRead":
        MsgMarkMsgAsRead(true);
        return;
      case "cmd_markAsUnread":
        MsgMarkMsgAsRead(false);
        return;
      case "cmd_markThreadAsRead":
        MsgMarkThreadAsRead();
        return;
      case "cmd_markAllRead":
        gDBView.doCommand(nsMsgViewCommandType.markAllRead);
        return;
      case "button_junk":
        MsgJunk();
        return;
      case "cmd_stop":
        MsgStop();
        return;
      case "cmd_toggleFlagged":
        MsgMarkAsFlagged();
        return;
      case "cmd_markAsFlagged":
        MsgMarkAsFlagged(true);
        return;
      case "cmd_markAsNotFlagged":
        MsgMarkAsFlagged(false);
        return;
      case "cmd_togglePending":
        MsgMarkAsPending();
        return;
      case "cmd_markAsNotPending":
        MsgMarkAsPending(false);
        return;
      case "cmd_markAsPending":
        MsgMarkAsPending(true);
        return;
      case "cmd_toggleJunk":
        JunkSelectedMessages();
        return;
      case "cmd_markAsJunk":
        JunkSelectedMessages(true);
        return;
      case "cmd_markAsNotJunk":
        JunkSelectedMessages(false);
        return;
      case "cmd_recalculateJunkScore":
        analyzeMessagesForJunk();
        return;
      case "cmd_applyFilters":
        MsgApplyFilters(null);
        return;
      case "cmd_runJunkControls":
        filterFolderForJunk();
        return;
      case "cmd_deleteJunk":
        deleteJunkInFolder();
        return;
      case "cmd_emptyTrash":
        MsgEmptyTrash();
        return;
      case "cmd_compactFolder":
        MsgCompactFolder(true);
        return;
      case "cmd_downloadFlagged":
          MsgDownloadFlagged();
          break;
      case "cmd_downloadSelected":
          MsgDownloadSelected();
          break;
      case "cmd_synchronizeOffline":
          MsgSynchronizeOffline();
          break;
      case "cmd_settingsOffline":
          MailOfflineMgr.openOfflineAccountSettings();
          break;
      case "cmd_moveToFolderAgain":
          var folderId = pref.getCharPref("mail.last_msg_movecopy_target_uri");
          if (pref.getBoolPref("mail.last_msg_movecopy_was_move"))
            MsgMoveMessage(folderId);
          else
            MsgCopyMessage(folderId);
          break;
      case "cmd_selectAll":
          // move the focus so the user can delete the newly selected messages, not the folder
          SetFocusThreadPane();
          // if in threaded mode, the view will expand all before selecting all
          gDBView.doCommand(nsMsgViewCommandType.selectAll)
          if (gDBView.numSelected != 1) {
              setTitleFromFolder(gDBView.msgFolder,null);
              ClearMessagePane();
          }
          break;
      case "cmd_selectThread":
          gDBView.doCommand(nsMsgViewCommandType.selectThread);
          break;
      case "cmd_newTask":
        ShowToDoPanel(null /* anchor */);
        break;
      case "cmd_viewMessages":
        gFocusPane.onKindChange('messages');
        break;
      case "cmd_viewAttachments":
        gFocusPane.onKindChange('attachments');
        break;
      case "cmd_viewImages":
        gFocusPane.onKindChange('images');
        break;
      case "cmd_viewtodos":
        gFocusPane.onKindChange('todos');
        break;
      case "cmd_rename":
        gDBView.doCommand(nsMsgViewCommandType.rename);
        break;
      case "cmd_indexAllMessages":
      case "cmd_suggestIndexAllMessages":
        indexMessages("" /* aFolderURI */, false /* aReset */);
        break;
      case "cmd_resetIndexAllMessages":
        indexMessages("" /* aFolderURI */, true /* aReset */);
        break;
      case "cmd_indexMessagesInFolder":
      case "cmd_suggestIndexMessagesInFolder":
        indexMessages(GetSelectedFolderURI(), false /* aReset */);
        break;
      case "cmd_resetIndexMessagesInFolder":
        indexMessages(GetSelectedFolderURI(), true /* aReset */);
        break;
    }
  },

  onEvent: function(event)
  {
    // on blur events set the menu item texts back to the normal values
    if ( event == 'blur' )
    {
      goSetMenuValue('cmd_undo', 'valueDefault');
      goSetMenuValue('cmd_redo', 'valueDefault');
    }
  }
};

function GetNumSelectedMessages()
{
  if (!gDBView)
    return 0;
    try {
        return gDBView.numSelected;
    }
    catch (ex) {
        return 0;
    }
}

var gLastFocusedElement=null;

function FocusRingUpdate_Mail()
{
  // WhichPaneHasFocus() uses on top.document.commandDispatcher.focusedElement
  // to determine which pane has focus
  // if the focusedElement is null, we're here on a blur.
  // nsFocusController::Blur() calls nsFocusController::SetFocusedElement(null),
  // which will update any commands listening for "focus".
  // we really only care about nsFocusController::Focus() happens,
  // which calls nsFocusController::SetFocusedElement(element)
  var currentFocusedElement = WhichPaneHasFocus();

  if (currentFocusedElement != gLastFocusedElement) {
    if (currentFocusedElement)
      currentFocusedElement.setAttribute("focusring", "true");

    if (gLastFocusedElement)
      gLastFocusedElement.removeAttribute("focusring");

    gLastFocusedElement = currentFocusedElement;

    // since we just changed the pane with focus we need to update the toolbar to reflect this
    // XXX TODO
    // can we optimize
    // and just update cmd_delete and button_delete?
    UpdateMailToolbar("focus");
  }
}

function WhichPaneHasFocus()
{
  var threadTree = GetThreadTree();
  var folderTree = GetFolderTree();
  var messagePane = GetMessagePane();
  let focusPane = document.getElementById('focusPaneBox');
  let folderPane = document.getElementById('folderPaneBox');
  let richSearchPane = document.getElementById('searchResultsList');

  if (top.document.commandDispatcher.focusedWindow == GetMessagePaneFrame())
    return messagePane;

  var currentNode = top.document.commandDispatcher.focusedElement;
  while (currentNode) {
    if (currentNode === threadTree ||
        currentNode === folderPane ||
        currentNode === focusPane ||
        currentNode === richSearchPane ||
        currentNode === messagePane)
      return currentNode;

    currentNode = currentNode.parentNode;
  }

  return null;
}

function SetupCommandUpdateHandlers()
{
  // folder pane
  var widget = document.getElementById("folderTree");
  if ( widget )
    widget.controllers.appendController(FolderPaneController);
}

// Called from <msgMail3PaneWindow.js>.
function UnloadCommandUpdateHandlers()
{
  var widget = GetFolderTree();
  if (widget)
    widget.controllers.removeController(FolderPaneController);
}

function IsSubscribeEnabled()
{
  try
  {
    var allServers = accountManager.allServers;

    for (var i=0;i<allServers.Count();i++)
    {
      var currentServer = allServers.GetElementAt(i).QueryInterface(Components.interfaces.nsIMsgIncomingServer);
      // only enable "File | Subscribe..." if we have one nntp or imap account
      // see bug #6655 for details
      if (currentServer.type == "nntp" || currentServer.type == "imap")
        return true;
    }
  }
  catch (ex)
  {
    // unexpected
  }
  return false;
}

function IsSendUnsentMsgsEnabled(folderResource)
{
  var identity;

  var msgSendlater =
    Components.classes["@mozilla.org/messengercompose/sendlater;1"]
              .getService(Components.interfaces.nsIMsgSendLater);

  // If we're currently sending unsent msgs, disable this cmd.
  if (msgSendlater.sendingMessages)
    return false;
  try {
    if (folderResource) {
      // if folderResource is non-null, it is
      // resource for the "Unsent Messages" folder
      // we're here because we've done a right click on the "Unsent Messages"
      // folder (context menu)
      var msgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);
      return (msgFolder.getTotalMessages(false) > 0);
    }
    else {
      var folders = GetSelectedMsgFolders();
      if (folders.length > 0) {
        identity = getIdentityForServer(folders[0].server);
      }
    }
  }
  catch (ex) {
    dump("IsSendUnsentMsgsEnabled 1 ex = " + ex + "\n");
    identity = null;
  }

  try {
    if (!identity) {
      var am = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
      identity = am.defaultAccount.defaultIdentity;
    }

    var unsentMsgsFolder = msgSendlater.getUnsentMessagesFolder(identity);
    return (unsentMsgsFolder.getTotalMessages(false) > 0);
  }
  catch (ex) {
    dump("IsSendUnsentMsgsEnabled 2 ex = " + ex + "\n");
  }
  return false;
}

/**
 * task creation is only enabled when we are in a folder tab, we aren't in a quick search
 * and the selected folder supports the ability to file messages or is a smart folder
 * and the 
 */
function IsNewTaskEnabled()
{
  // make sure we are in a folder tab
  let canFileMessages = false;
  var folder = GetFolderResource(GetFolderTree(), GetSelectedFolderIndex());
  if (folder && folder instanceof Components.interfaces.nsIMsgFolder)
  {
    canFileMessages = folder.canFileMessages;
    if (SmartServerUtils.isSmartFolder(folder))
    {
      let folders = SmartServerUtils.foldersForSmartFolder(folder);
      canFileMessages = folders.length ? folders[0].canFileMessages : false;
    }
  }
    
  return document.getElementById('tabmail').currentTabOwner.type == 'folder' &&
         canFileMessages && 
         getSearchInputVal() == '';
}

function IsRenameFolderEnabled()
{
  var folderTree = GetFolderTree();
  var selection = folderTree.view.selection;
  if (selection.count == 1)
  {
    var startIndex = {};
    var endIndex = {};
    selection.getRangeAt(0, startIndex, endIndex);
    var folder = GetFolderResource(folderTree, startIndex.value);
    return folder.canRename && isCommandEnabled("cmd_renameFolder");
  }
  else
    return false;
}

function IsCanSearchMessagesEnabled()
{
  var folder = GetFolderResource(GetFolderTree(), GetSelectedFolderIndex());
  return folder && folder instanceof Components.interfaces.nsIMsgFolder && folder.server.canSearchMessages;
}

function IsFolderCharsetEnabled()
{
  return IsFolderSelected();
}

function IsPropertiesEnabled(command)
{
   // properties should be enabled for folders and servers but not fake accounts
   if (!FolderPaneSelectionIsMailFolder())
     return false;
     
   try
   {
     var folder = GetFolderResource(GetFolderTree(), GetSelectedFolderIndex());
     if (folder instanceof Components.interfaces.nsIMsgFolder)
     {
        if (SmartServerUtils.isSmartFolder(folder))
          return false;
        // when servers are selected it should be "Edit | Properties..."
        if (folder.isServer)
          goSetMenuValue(command, "valueGeneric");
        else
          goSetMenuValue(command, folder.server.type == 'nntp' ? "valueNewsgroup" : "valueFolder");
      }
   }
   catch (ex)
   {
      // properties menu failure
   }

   var selection = GetFolderTree().view.selection;
   return (selection.count == 1);
}

/**
 * We currently only allow view navigation from folder tabs and not from a stand alone message tab
 */
function IsViewNavigationItemEnabled()
{
  return IsFolderSelected() && document.getElementById('tabmail').currentTabOwner.type == 'folder';
}

function IsFolderSelected()
{
  var folder = GetFolderResource(GetFolderTree(), GetSelectedFolderIndex());
  return folder && folder instanceof Components.interfaces.nsIMsgFolder && !folder.isServer;
}

function IsMessageDisplayedInMessagePane()
{
  // for Postbox conversation mode, if more than one message is selected but we're in conversation
  // we consider a message as being displayed in the message pane.
  // see bug #5930 for details
  return (!IsMessagePaneCollapsed() && (GetNumSelectedMessages() == 1 || (GetNumSelectedMessages() > 1 && InConversationMode())));
}

function MsgDeleteFolder()
{
  var folderTree = GetFolderTree();
  var selectedFolders = GetSelectedMsgFolders();
  for (var i = 0; i < selectedFolders.length; i++)
  {
    var folder = selectedFolders[i];
    if (!(folder.flags & MSG_FOLDER_FLAG_INBOX || folder.flags & MSG_FOLDER_FLAG_TRASH))
    {
      if (folder.flags & MSG_FOLDER_FLAG_VIRTUAL)
      {
        if (gCurrentVirtualFolderUri == folder.URI)
          gCurrentVirtualFolderUri = null;
        // prompt the user
        var confirmMsg = gMessengerBundle.getString("confirmSavedSearchDeleteMessage");
        var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
                              getService(Components.interfaces.nsIPromptService);
        if (promptService.confirm(window, "", confirmMsg))
        {
          var children = Components.classes["@mozilla.org/supports-array;1"].
                           createInstance(Components.interfaces.nsISupportsArray);
          children.AppendElement(folder);
          folder.parent.deleteSubFolders(children, msgWindow);
        }
        continue;
      }

      var protocolInfo = Components.classes["@mozilla.org/messenger/protocol/info;1?type=" + folder.server.type].getService(Components.interfaces.nsIMsgProtocolInfo);
      // do not allow deletion of special folders on imap accounts
      if ((folder.flags & MSG_FOLDER_FLAG_SENTMAIL ||
          folder.flags & MSG_FOLDER_FLAG_DRAFTS ||
          folder.flags & MSG_FOLDER_FLAG_TEMPLATES ||
          (folder.flags & MSG_FOLDER_FLAG_JUNK && !CanRenameDeleteJunkMail(GetSelectedFolderURI()))) &&
          !protocolInfo.specialFoldersDeletionAllowed)
      {
          var errorMessage = gMessengerBundle.getFormattedString("specialFolderDeletionErr",
                                              [specialFolder]);
          var specialFolderDeletionErrTitle = gMessengerBundle.getString("specialFolderDeletionErrTitle");
          promptService.alert(window, specialFolderDeletionErrTitle, errorMessage);
          continue;
      }
      else if (folder.server.type == 'nntp')
      {
        var unsubscribe = ConfirmUnsubscribe(selectedFolder);
        if (ConfirmUnsubscribe(selectedFolder))
          UnSubscribe(selectedFolder);
      }
      else
      {
        var children = Components.classes["@mozilla.org/supports-array;1"].
                         createInstance(Components.interfaces.nsISupportsArray);
        children.AppendElement(folder);
        folder.parent.deleteSubFolders(children, msgWindow);
      }
    }
  }
}

function SetFocusThreadPaneIfNotOnMessagePane()
{
  var focusedElement = WhichPaneHasFocus();

  if((focusedElement != GetThreadTree()) &&
     (focusedElement != GetMessagePane()))
     SetFocusThreadPane();
}

// 3pane related commands.  Need to go in own file.  Putting here for the moment.
function MsgNextMessage()
{
  GoNextMessage(nsMsgNavigationType.nextMessage, false );
}

function MsgNextUnreadMessage()
{
  GoNextMessage(nsMsgNavigationType.nextUnreadMessage, true);
}
function MsgNextFlaggedMessage()
{
  GoNextMessage(nsMsgNavigationType.nextFlagged, true);
}

function MsgNextUnreadThread()
{
  GoNextMessage(nsMsgNavigationType.nextUnreadThread, true);
}

function MsgPreviousMessage()
{
    GoNextMessage(nsMsgNavigationType.previousMessage, false);
}

function MsgPreviousUnreadMessage()
{
  GoNextMessage(nsMsgNavigationType.previousUnreadMessage, true);
}

function MsgPreviousFlaggedMessage()
{
  GoNextMessage(nsMsgNavigationType.previousFlagged, true);
}

function MsgGoForward()
{
  GoNextMessage(nsMsgNavigationType.forward, true);
}

function MsgGoBack()
{
  GoNextMessage(nsMsgNavigationType.back, true);
}

function SwitchPaneFocus(event)
{                        
  var folderTree = GetFolderTree();
  var threadTree = GetThreadTree();
  var messagePane = GetMessagePane();
  let focusPane = document.getElementById('focusPaneBox');
  let folderPane = document.getElementById('folderPaneBox');
  let focusPaneIsCollapsed = focusPane.getAttribute('state') == 'collapsed';
  let richSearchPane = document.getElementById('searchResultsList');
  var focusedElement = WhichPaneHasFocus();
  if (focusedElement == null)       // focus not on one of the main three panes (probably toolbar)
    focusedElement = threadTree;    // treat as if on thread tree

  if (event && event.shiftKey || (event.type == 'keypress' && event.keyCode == KeyEvent.DOM_VK_LEFT))
  {
    // Reverse traversal: Message -> Thread -> Focus -> Folder -> Message
    if ((focusedElement == focusPane || ((focusedElement == threadTree || focusedElement == richSearchPane) && focusPaneIsCollapsed)) && !IsFolderPaneCollapsed())
      folderTree.focus();
    else if ((focusedElement == threadTree || focusedElement == richSearchPane) && !focusPaneIsCollapsed)
      document.getElementById('focusPaneAttributeList').focus();
    else if (focusedElement != messagePane && !IsMessagePaneCollapsed())
      SetFocusMessagePane();
    else if (ShowingRichSearchResults())
      richSearchPane.richlistbox.focus();
    else
      threadTree.focus();
  }
  else
  {
    // Forward traversal: Folder -> Focus -> Thread -> Message -> Folder
    if (focusedElement == threadTree && !IsMessagePaneCollapsed())
      SetFocusMessagePane();
    else if (focusedElement == folderPane && !focusPaneIsCollapsed)
      document.getElementById('focusPaneAttributeList').focus();
    else if ((focusedElement == threadTree || focusedElement == messagePane || focusedElement == richSearchPane) && !IsFolderPaneCollapsed())
      folderTree.focus();
    else if (ShowingRichSearchResults())
      richSearchPane.richlistbox.focus();
    else
      threadTree.focus();
  }
}

function SetFocusFolderPane()
{
    var folderTree = GetFolderTree();
    folderTree.focus();
}

function SetFocusThreadPane()
{
    var threadTree = GetThreadTree();
    threadTree.focus();
}

function SetFocusMessagePane()
{
  // Calling .focus() on content doesn't blur the previously focused chrome
  // element, so we shift focus to the XUL pane first, to not leave another
  // pane looking like it has focus.
  GetMessagePane().focus();
  GetMessagePaneFrame().focus();
}

function is_collapsed(element)
{
  return (element.getAttribute('state') == 'collapsed');
}

function isCommandEnabled(cmd)
{
  var selectedFolders = GetSelectedMsgFolders();
  var numFolders = selectedFolders.length;
  if(numFolders != 1)
    return false;

  var folder = selectedFolders[0];
  if (!folder)
    return false;
  else
    return folder.isCommandEnabled(cmd);

}

/* Returns true if the selected item in the folder pane is a mail folder
    This is used to keep us from enabling  commands and menu items that assume
    the folder pane always has a mail folder selected.
*/
function FolderPaneSelectionIsMailFolder()
{
  var folder = GetFolderResource(GetFolderTree(), GetSelectedFolderIndex());
  return folder && folder instanceof Components.interfaces.nsIMsgFolder && 
         !(SmartServerUtils.isSmartFolder(folder) && SmartServerUtils.getSortedAccountsForSmartServer(folder.server).length == 0);
}

//
// This function checks if the configured junk mail can be renamed or deleted.
//
function CanRenameDeleteJunkMail(aFolderUri)
{
  if (!aFolderUri)
    return false;

  // Go through junk mail settings for all servers and see if the folder is set/used by anyone.
  try
  {
    var allServers = accountManager.allServers;

    for (var i=0;i<allServers.Count();i++)
    {
      var currentServer = allServers.GetElementAt(i).QueryInterface(Components.interfaces.nsIMsgIncomingServer);
      var settings = currentServer.spamSettings;
      // If junk mail control or move junk mail to folder option is disabled then
      // allow the folder to be removed/renamed since the folder is not used in this case.
      if (!settings.level || !settings.moveOnSpam)
        continue;
      if (settings.spamFolderURI == aFolderUri)
        return false;
    }
  }
  catch(ex)
  {
      dump("Can't get all servers\n");
  }
  return true;
}
